// This is the Arabic 4 Mac Photoshop script for Adobe Photoshop CS3 on Mac
/// VERSION 0.2 MARCH 22 2009 (now supports lam+alifhamzeh ligatures)
// by Yaman Salahi, ysalahi@gmail.com, yamansalahi.com
// Project website: http://code.google.com/p/arabic-mac-photoshop

// charTable[x][0] = letter
// charTable[x][1] = base unicode
// charTable[x][2] = initial unicode
// charTable[x][3] = medial unicode
// charTable[x][4] = finalpos unicode
// charTable[x][5] = standalone unicode
// charTable[x][6] = connects?

var defaultRulerUnites = app.preferences.rulerUnits;
var defaultTypeUnits = app.preferences.typeUnits;
app.preferences.rulerUnits = Units.PIXELS;
app.preferences.typeUnits = TypeUnits.PIXELS;
var AD = app.activeDocument;

var arabicLayer = AD.activeLayer; //artLayers.getByName("Fix Arabic");
var arabicTextItem = arabicLayer.textItem;
var arabicString = arabicTextItem.contents;

// is special ligature
// special cases:
//  - shadda with any other vowel 
//  - any vowel
//  - spacing and height after the lam-alif character

var charTable = new Array(46);
charTable[0] = new Array(7);
charTable[0][0] = "arabic letter";
charTable[0][1] = "unicode base";
charTable[0][2] = "unicode beg.";
charTable[0][3] = "unicode med.";
charTable[0][4] = "unicode end";
charTable[0][5] = "unicode alone";
charTable[0][6] = "connects";
charTable[1] = new Array(7);
charTable[1][0] = "ا";
charTable[1][1] = "\u0627";
charTable[1][2] = "\uFE8D";
charTable[1][3] = "\uFE8E";
charTable[1][4] = "\uFE8E";
charTable[1][5] = "\uFE8D";
charTable[1][6] = "no";
charTable[2] = new Array(7);
charTable[2][0] = "ب";
charTable[2][1] = "\u0628";
charTable[2][2] = "\uFE91";
charTable[2][3] = "\uFE92";
charTable[2][4] = "\uFE90";
charTable[2][5] = "\uFE8F";
charTable[2][6] = "yes";
charTable[3] = new Array(7);
charTable[3][0] = "ت";
charTable[3][1] = "\u062A";
charTable[3][2] = "\uFE97";
charTable[3][3] = "\uFE98";
charTable[3][4] = "\uFE96";
charTable[3][5] = "\uFE95";
charTable[3][6] = "yes";
charTable[4] = new Array(7);
charTable[4][0] = "ث";
charTable[4][1] = "\u062B";
charTable[4][2] = "\uFE9B";
charTable[4][3] = "\uFE9C";
charTable[4][4] = "\uFE9A";
charTable[4][5] = "\uFE99";
charTable[4][6] = "yes";
charTable[5] = new Array(7);
charTable[5][0] = "ج";
charTable[5][1] = "\u062C";
charTable[5][2] = "\uFE9F";
charTable[5][3] = "\uFEA0";
charTable[5][4] = "\uFE9E";
charTable[5][5] = "\uFE9D";
charTable[5][6] = "yes";
charTable[6] = new Array(7);
charTable[6][0] = "ح";
charTable[6][1] = "\u062D";
charTable[6][2] = "\uFEA3";
charTable[6][3] = "\uFEA4";
charTable[6][4] = "\uFEA2";
charTable[6][5] = "\uFEA1";
charTable[6][6] = "yes";
charTable[7] = new Array(7);
charTable[7][0] = "خ";
charTable[7][1] = "\u062E";
charTable[7][2] = "\uFEA7";
charTable[7][3] = "\uFEA8";
charTable[7][4] = "\uFEA6";
charTable[7][5] = "\uFEA5";
charTable[7][6] = "yes";
charTable[8] = new Array(7);
charTable[8][0] = "د";
charTable[8][1] = "\u062F";
charTable[8][2] = "\uFEA9";
charTable[8][3] = "\uFEAA";
charTable[8][4] = "\uFEAA";
charTable[8][5] = "\uFEA9";
charTable[8][6] = "no";
charTable[9] = new Array(7);
charTable[9][0] = "ذ";
charTable[9][1] = "\u0630";
charTable[9][2] = "\uFEAB";
charTable[9][3] = "\uFEAC";
charTable[9][4] = "\uFEAC";
charTable[9][5] = "\uFEAB";
charTable[9][6] = "no";
charTable[10] = new Array(7);
charTable[10][0] = "ر";
charTable[10][1] = "\u0631";
charTable[10][2] = "\uFEAD";
charTable[10][3] = "\uFEAE";
charTable[10][4] = "\uFEAE";
charTable[10][5] = "\uFEAD";
charTable[10][6] = "no";
charTable[11] = new Array(7);
charTable[11][0] = "ز";
charTable[11][1] = "\u0632";
charTable[11][2] = "\uFEAF";
charTable[11][3] = "\uFEB0";
charTable[11][4] = "\uFEB0";
charTable[11][5] = "\uFEAF";
charTable[11][6] = "no";
charTable[12] = new Array(7);
charTable[12][0] = "س";
charTable[12][1] = "\u0633";
charTable[12][2] = "\uFEB3";
charTable[12][3] = "\uFEB4";
charTable[12][4] = "\uFEB2";
charTable[12][5] = "\uFEB1";
charTable[12][6] = "yes";
charTable[13] = new Array(7);
charTable[13][0] = "ش";
charTable[13][1] = "\u0634";
charTable[13][2] = "\uFEB7";
charTable[13][3] = "\uFEB8";
charTable[13][4] = "\uFEB6";
charTable[13][5] = "\uFEB5";
charTable[13][6] = "yes";
charTable[14] = new Array(7);
charTable[14][0] = "ص";
charTable[14][1] = "\u0635";
charTable[14][2] = "\uFEBB";
charTable[14][3] = "\uFEBC";
charTable[14][4] = "\uFEBA";
charTable[14][5] = "\uFEB9";
charTable[14][6] = "yes";
charTable[15] = new Array(7);
charTable[15][0] = "ض";
charTable[15][1] = "\u0636";
charTable[15][2] = "\uFEBF";
charTable[15][3] = "\uFEC0";
charTable[15][4] = "\uFEBE";
charTable[15][5] = "\uFEBD";
charTable[15][6] = "yes";
charTable[16] = new Array(7);
charTable[16][0] = "ط";
charTable[16][1] = "\u0637";
charTable[16][2] = "\uFEC3";
charTable[16][3] = "\uFEC4";
charTable[16][4] = "\uFEC2";
charTable[16][5] = "\uFEC1";
charTable[16][6] = "yes";
charTable[17] = new Array(7);
charTable[17][0] = "ظ";
charTable[17][1] = "\u0638";
charTable[17][2] = "\uFEC7";
charTable[17][3] = "\uFEC8";
charTable[17][4] = "\uFEC6";
charTable[17][5] = "\uFEC5";
charTable[17][6] = "yes";
charTable[18] = new Array(7);
charTable[18][0] = "ع";
charTable[18][1] = "\u0639";
charTable[18][2] = "\uFECB";
charTable[18][3] = "\uFECC";
charTable[18][4] = "\uFECA";
charTable[18][5] = "\uFEC9";
charTable[18][6] = "yes";
charTable[19] = new Array(7);
charTable[19][0] = "غ";
charTable[19][1] = "\u063A";
charTable[19][2] = "\uFECF";
charTable[19][3] = "\uFED0";
charTable[19][4] = "\uFECE";
charTable[19][5] = "\uFECD";
charTable[19][6] = "yes";
charTable[20] = new Array(7);
charTable[20][0] = "ف";
charTable[20][1] = "\u0641";
charTable[20][2] = "\uFED3";
charTable[20][3] = "\uFED4";
charTable[20][4] = "\uFED2";
charTable[20][5] = "\uFED1";
charTable[20][6] = "yes";
charTable[21] = new Array(7);
charTable[21][0] = "ق";
charTable[21][1] = "\u0642";
charTable[21][2] = "\uFED7";
charTable[21][3] = "\uFED8";
charTable[21][4] = "\uFED6";
charTable[21][5] = "\uFED5";
charTable[21][6] = "yes";
charTable[22] = new Array(7);
charTable[22][0] = "ك";
charTable[22][1] = "\u0643";
charTable[22][2] = "\uFEDB";
charTable[22][3] = "\uFEDC";
charTable[22][4] = "\uFEDA";
charTable[22][5] = "\uFED9";
charTable[22][6] = "yes";
charTable[23] = new Array(7);
charTable[23][0] = "ل";
charTable[23][1] = "\u0644";
charTable[23][2] = "\uFEDF";
charTable[23][3] = "\uFEE0";
charTable[23][4] = "\uFEDE";
charTable[23][5] = "\uFEDD";
charTable[23][6] = "yes";
charTable[24] = new Array(7);
charTable[24][0] = "م";
charTable[24][1] = "\u0645";
charTable[24][2] = "\uFEE3";
charTable[24][3] = "\uFEE4";
charTable[24][4] = "\uFEE2";
charTable[24][5] = "\uFEE1";
charTable[24][6] = "yes";
charTable[25] = new Array(7);
charTable[25][0] = "ن";
charTable[25][1] = "\u0646";
charTable[25][2] = "\uFEE7";
charTable[25][3] = "\uFEE8";
charTable[25][4] = "\uFEE6";
charTable[25][5] = "\uFEE5";
charTable[25][6] = "yes";
charTable[26] = new Array(7);
charTable[26][0] = "ه";
charTable[26][1] = "\u0647";
charTable[26][2] = "\uFEEB";
charTable[26][3] = "\uFEEC";
charTable[26][4] = "\uFEEA";
charTable[26][5] = "\uFEE9";
charTable[26][6] = "yes";
charTable[27] = new Array(7);
charTable[27][0] = "و";
charTable[27][1] = "\u0648";
charTable[27][2] = "\uFEED";
charTable[27][3] = "\uFEEE";
charTable[27][4] = "\uFEEE";
charTable[27][5] = "\uFEED";
charTable[27][6] = "no";
charTable[28] = new Array(7);
charTable[28][0] = "ي";
charTable[28][1] = "\u064A";
charTable[28][2] = "\uFEF3";
charTable[28][3] = "\uFEF4";
charTable[28][4] = "\uFEF2";
charTable[28][5] = "\uFEF1";
charTable[28][6] = "yes";
charTable[29] = new Array(7);
charTable[29][0] = "أ";
charTable[29][1] = "\u0623";
charTable[29][2] = "\uFE83";
charTable[29][3] = "\uFE84";
charTable[29][4] = "\uFE84";
charTable[29][5] = "\uFE83";
charTable[29][6] = "no";
charTable[30] = new Array(7);
charTable[30][0] = "ئ";
charTable[30][1] = "\u0626";
charTable[30][2] = "\uFE8B";
charTable[30][3] = "\uFE8C";
charTable[30][4] = "\uFE8A";
charTable[30][5] = "\uFE89";
charTable[30][6] = "yes";
charTable[31] = new Array(7);
charTable[31][0] = "ؤ";
charTable[31][1] = "\u0624";
charTable[31][2] = "\uFE85";
charTable[31][3] = "\uFE86";
charTable[31][4] = "\uFE86";
charTable[31][5] = "\uFE85";
charTable[31][6] = "no";
charTable[32] = new Array(7);
charTable[32][0] = "ى";
charTable[32][1] = "\u0649";
charTable[32][2] = "";
charTable[32][3] = "";
charTable[32][4] = "\uFEF0";
charTable[32][5] = "\uFEEF";
charTable[32][6] = "yes";
charTable[33] = new Array(7);
charTable[33][0] = "آ";
charTable[33][1] = "\u0622";
charTable[33][2] = "\uFE81";
charTable[33][3] = "\uFE82";
charTable[33][4] = "\uFE82";
charTable[33][5] = "\uFE81";
charTable[33][6] = "yes";
charTable[34] = new Array(7);
charTable[34][0] = "ة";
charTable[34][1] = "\u0629";
charTable[34][2] = "";
charTable[34][3] = "";
charTable[34][4] = "\uFE94";
charTable[34][5] = "\uFE93";
charTable[34][6] = "yes";
charTable[35] = new Array(7);
charTable[35][0] = "إ";
charTable[35][1] = "\u0625";
charTable[35][2] = "\uFE87";
charTable[35][3] = "\uFE88";
charTable[35][4] = "\uFE88";
charTable[35][5] = "\uFE87";
charTable[35][6] = "no";
charTable[36] = new Array(7);
charTable[36][0] = "ء";
charTable[36][1] = "\u0621`";
charTable[36][2] = "\uFE80";
charTable[36][3] = "\uFE80";
charTable[36][4] = "\uFE80";
charTable[36][5] = "\uFE80";
charTable[36][6] = "yes";
charTable[37] = new Array(7);
charTable[37][0] = "ﻵ";
charTable[37][1] = "\uFEF5";
charTable[37][2] = "\uFEF5";
charTable[37][3] = "\uFEF6";
charTable[37][4] = "\uFEF6";
charTable[37][5] = "\uFEF5";
charTable[37][6] = "no";
charTable[38] = new Array(7);
charTable[38][0] = "ﻷ";
charTable[38][1] = "\uFEF7";
charTable[38][2] = "\uFEF7";
charTable[38][3] = "\uFEF8";
charTable[38][4] = "\uFEF8";
charTable[38][5] = "\uFEF7";
charTable[38][6] = "no";
charTable[39] = new Array(7);
charTable[39][0] = "ﻹ";
charTable[39][1] = "\uFEF9";
charTable[39][2] = "\uFEF9";
charTable[39][3] = "\uFEFA";
charTable[39][4] = "\uFEFA";
charTable[39][5] = "\uFEF9";
charTable[39][6] = "no";
charTable[40] = new Array(7);
charTable[40][0] = "ﻻ";
charTable[40][1] = "\uFEFB";
charTable[40][2] = "\uFEFB";
charTable[40][3] = "\uFEFC";
charTable[40][4] = "\uFEFC";
charTable[40][5] = "\uFEFB";
charTable[40][6] = "no";
charTable[41] = new Array(7);
charTable[41][0] = "ﳌ";
charTable[41][1] = "\uFCCC";
charTable[41][2] = "";
charTable[41][3] = "";
charTable[41][4] = "";
charTable[41][5] = "";
charTable[41][6] = "yes";
charTable[42] = new Array(7);
charTable[42][0] = "ﲍ";
charTable[42][1] = "\uFC8D";
charTable[42][2] = "";
charTable[42][3] = "";
charTable[42][4] = "";
charTable[42][5] = "";
charTable[42][6] = "yes";
charTable[43] = new Array(7);
charTable[43][0] = "ﲔ";
charTable[43][1] = "\uFC94";
charTable[43][2] = "";
charTable[43][3] = "";
charTable[43][4] = "";
charTable[43][5] = "";
charTable[43][6] = "yes";
charTable[44] = new Array(7);
charTable[44][0] = "ﱳ";
charTable[44][1] = "\uFC73";
charTable[44][2] = "";
charTable[44][3] = "";
charTable[44][4] = "";
charTable[44][5] = "";
charTable[44][6] = "yes";
charTable[45] = new Array(7);
charTable[45][0] = "ﱭ";
charTable[45][1] = "\uFC6D";
charTable[45][2] = "";
charTable[45][3] = "";
charTable[45][4] = "";
charTable[45][5] = "";
charTable[45][6] = "yes";

// Info about Special Characters
var specialTable = new Array(9);

specialTable[0] = new Array(2);
specialTable[0][0] = "\u064B";  // tanwiin al fatah
specialTable[0][1] = "no"; // does it double with other markers?

specialTable[1] = new Array(2);
specialTable[1][0] = "\u064C"; // tanwiin al domm
specialTable[1][1] = "no"; // does it double with other markers?

specialTable[2] = new Array(2);
specialTable[2][0] = "\u064D"; // tanwiin al kasr
specialTable[2][1] = "no"; // does it double with other markers?

specialTable[3] = new Array(2);
specialTable[3][0] = "\u064E"; // fatha
specialTable[3][1] = "no"; // does it double with other markers?

specialTable[4] = new Array(2);
specialTable[4][0] = "\u064F"; // damma
specialTable[4][1] = "no"; // does it double with other markers?

specialTable[5] = new Array(2);
specialTable[5][0] = "\u0650"; // kasra
specialTable[5][1] = "no"; // does it double with other markers?

specialTable[6] = new Array(2);
specialTable[6][0] = "\u0651"; // shadda (can be doubled with the others!)
specialTable[6][1] = "yes"; // does it double with other markers?

specialTable[7] = new Array(2);
specialTable[7][0] = "\u0652"; // sukoon
specialTable[7][1] = "no"; // does it double with other markers?

specialTable[8] = new Array(2);
specialTable[8][0] = "\u0653"; // madda
specialTable[8][1] = "no"; // does it double with other markers?

var letter = 0;
var base = 1;
var initial = 2;
var medial = 3;
var finalpos = 4;
var alone = 5;
var connects = 6;

function isSpecial(match) {
  for(var c = 0; c < specialTable.length; c++) {
    if(specialTable[c][0]==match) {
      return c;
    }   
  }
  return -1;
}

function specialChar(character, line, word, attachTo, shared) {
	this.character = character;
	this.line = line;
	this.word = word;
	this.attachTo = attachTo;
	this.shared = shared;
}

function getRow(unicodeValue) {
	for(var i = 1; i < charTable.length; i++) {
		//alert(charTable[i][letter] + " " + unicodeValue);
		if(charTable[i][letter] == unicodeValue)
			return i;
	}
	return -1;
}

function reverseString(str) {
	var newstr = "";
	for(var i = str.length-1; i >= 0; i--)
		newstr += str.charAt(i);
	return newstr;
}

function fixWord(word) {
	var newstr = "";
	for(var l = 0; l < word.length; l++) {
		var row = getRow(word.charAt(l));
		var prev = l-1;
		var prevRow = -1;
		if(prev >= 0) prevRow = getRow(word.charAt(prev));

		var offset = 0;
		if(row < 0) {
				//alert(word.charAt(l) + " was not found in the table");
			newstr += word.charAt(l);
			continue;			
		}

			
		// look for special conditions:
		// lam  + alif/alif hamza on top/alif hamza on bottom
		// lam + mim
		if(l == 0) { // at the beginning
			if(word.length == 1) // and also the end
				newstr += charTable[row][alone];
			else if(charTable[row][connects] == "yes") { // beg. 
				if(l <= word.length - 2 && word.charAt(l) == "ل" && word.charAt(l+1) == "ا") {
					newstr += charTable[getRow("ﻻ")][initial];
					offset = 1;
				} else if(l <= word.length - 2 && word.charAt(l) == "ل" && word.charAt(l+1) == "أ") {
					newstr += charTable[getRow("ﻷ")][initial];
					offset = 1;
				} else if(l <= word.length - 2 && word.charAt(l) == "ل" && word.charAt(l+1) == "إ") {
					newstr += charTable[getRow("ﻹ")][initial];
					offset = 1;
				}
				else
					newstr += charTable[row][initial];
			}
			else // standalone
				newstr += charTable[row][alone];
		}
		else if(l == word.length-1) { // it's at the end
			if(prev >= 0 && prevRow >= 0 && charTable[prevRow][connects] == "yes") // prev connects
				newstr += charTable[row][finalpos];
			else
				newstr += charTable[row][alone];
		}
		else { // it's in the middle
			if(prev >= 0 && prevRow >= 0 && charTable[prevRow][connects] == "yes") { // medial preceded by connector
				//l <= word.length - 2 &&
				if(word.charAt(l) == "ل" && word.charAt(l+1) == "ا") {	
					newstr += charTable[getRow("ﻻ")][medial];
					offset = 1;
				} else if(l <= word.length - 2 && word.charAt(l) == "ل" && word.charAt(l+1) == "أ") {
					newstr += charTable[getRow("ﻷ")][medial];
					offset = 1;
				} else if(l <= word.length - 2 && word.charAt(l) == "ل" && word.charAt(l+1) == "إ") {
					newstr += charTable[getRow("ﻹ")][medial];
					offset = 1;
				}
				else
					newstr += charTable[row][medial];									
			}
			else {	// preceded by non-connector 
				if(word.charAt(l) == "ل" && word.charAt(l+1) == "ا") {
					newstr += charTable[getRow("ﻻ")][initial];
					offset = 1;
				} else if(l <= word.length - 2 && word.charAt(l) == "ل" && word.charAt(l+1) == "أ") {
					newstr += charTable[getRow("ﻷ")][initial];
					offset = 1;
				} else if(l <= word.length - 2 && word.charAt(l) == "ل" && word.charAt(l+1) == "إ") {
					newstr += charTable[getRow("ﻹ")][initial];
					offset = 1;
				}
				else
					newstr += charTable[row][initial];				
			}
		}	
		l+= offset;
		prev = l;
	}
	return newstr;
}

function cleanWord(currWord, line, word) {
	var results = new Array(2); // first entry is collection of special characters
				    // second entry is the clean string

	var newWord = "";
	var previousIsSpecial = false;
	var specialChars = new Array();
	for(var j = 0; j < currWord.length; j++) {
		var specialRow = -1;
		if((specialRow = isSpecial(currWord.charAt(j))) >= 0) {
			var idx = j-1;
			if(idx < 0) idx = 0;
			if(previousIsSpecial)
				idx--;
			var foundChar = new specialChar(specialRow, line, word, idx, previousIsSpecial);
			specialChars.splice(specialChars.length, 0, foundChar);
			previousIsSpecial = true;
		} else {
			newWord += currWord[j];
			previousIsSpecial = false;
		}
	}

	var result = new Array(specialChars, newWord);
	return result;
}

function fixIt() {
	var arabicLines = arabicString.split("\r");
	var arabicWords = new Array(arabicLines.length);
	
	var allText = "";
	var newStr = "";

	var arabicPreText = arabicString;
	var arabicCleanText = "";
	var arabicFormattedText = "";
	var reversedStr = "";

	var virtualLayer = arabicLayer.duplicate();
	virtualLayer.name = "Virtual Layer";
	virtualLayer.visible = false;
	var virtualText = virtualLayer.textItem;
	virtualText.contents = "Not Changed";

	for(var line = 0; line < arabicLines.length; line++) {
		var currLine = arabicLines[line];
		arabicWords[line] = currLine.split(" ");
		var reversedLine = "";
		
		for(var w = arabicWords[line].length-1; w >= 0; w--) {
			var word = arabicWords[line][w];
			var result = cleanWord(word, line, w);
			var specialChars = result[0];

			word = result[1];
			word = fixWord(word);
			word = reverseString(word);			
			
			arabicWords[line][w] = word;
			
			// create special layers?
			if(specialChars.length > 0) {
				for(var s = 0; s < specialChars.length; s++) {
					var newTextLayer = arabicLayer.duplicate();
					newTextLayer.name = "Diacritic: " + line + "," + w + ": " + s;
					
					var newTextItem = newTextLayer.textItem;
					newTextItem.contents = specialTable[specialChars[s].character][0];
				
					// x offset: width
					if(specialChars[s].attachTo >= 0) {
						virtualText.contents = reversedLine + arabicWords[line][w].substring(0, specialChars[s].attachTo);
						newTextLayer.translate(-Math.abs(
								virtualLayer.bounds[0] - virtualLayer.bounds[2]), 0);

						if(line > 0) {
							var leading = 0;
							if(newTextItem.useAutoLeading)
								leading = newTextItem.autoLeadingAmount;
							else
								leading = newTextItem.leading;
	
							//alert(leading);
							newTextLayer.translate(0, line*leading/10);
						}
					}

					if(s < specialChars.length - 1 && specialChars[s+1].shared) {
						newTextItem.contents += specialTable[specialChars[s+1].character][0];
						s++;
					}
				}
			}
			reversedLine += arabicWords[line][w] + " ";
		}
		reversedStr += reversedLine + "\r";
	}

	virtualLayer.remove();
	// make reverse characters for each line
	var textLayerRef = arabicLayer.duplicate();
	textLayerRef.name = "Repaired: "+ textLayerRef.name;

	var textItemRef = textLayerRef.textItem; 
	textItemRef.contents = reversedStr;
	arabicLayer.visible = false;
}

fixIt();

